/*
 *	SecAODV IPv6 Project
 *
 *	See NIST-COPYRIGHT and COPYING for license.
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__ 1

#include <net/if.h>
#include "config_ip.h"

#define default_config_file "/etc/aodvd.conf"

struct iflist {
	char Name[IFNAMSIZ];
	int IfIndex;
	int SendHello;
	unsigned long HelloInterval;
	struct iflist *next;
};

#define MAXIFS 128

struct nodeconfig {
	int DebugLevel;
	int Log;
	char LogFile[256];
	int LogVerbosity;
	struct iflist *InterfaceList[MAXIFS];
	struct in6_addr NodeAddrGlobal;
	unsigned char GlobalPrefixLen;
	struct in6_addr NodeAddrSite;
	unsigned char SitePrefixLen;
	struct in6_addr HostAddrGlobal;
	unsigned char HostPrefixLen;
};

extern struct nodeconfig Config;

void config_parse(char *filename);

int config_cmdline(int argc, char **argv);

int config_getaddr(int scope, struct in6_addr *addr);

#endif /* __CONFIG_H__ */
