/*
 *	SecAODV IPv6 Project
 *
 *	See NIST-COPYRIGHT and COPYING for license.
 */

#ifndef __KINTERFACE_H__
#define __KINTERFACE_H__ 1

#include <asm/types.h>
#include <sys/types.h>
#include <linux/netlink.h>

struct nl_handle
{
	int			fd;
	struct sockaddr_nl	local;
	struct sockaddr_nl	peer;
	__u32			seq;
	__u32			dump;
};

int ip6q_init(struct nl_handle *nlh, unsigned mode);
int ip6q_listen(struct nl_handle *nlh);
int ip6q_send_verdict(struct nl_handle *nlh, unsigned int verdict, unsigned long id);
void ip6q_accept(unsigned long id);
void ip6q_drop(unsigned long id);
int ip6q_close(struct nl_handle *nlh);

#endif /* __KINTERFACE_H__ */
