/*
 *	SecAODV IPv6 Project
 *
 *	See NIST-COPYRIGHT and COPYING for license.
 */

#include "popup.h"

int sUILen = 0, sAODVLen = 0;
int sockd = 0;

struct sockaddr_un  sUISock  = { PF_UNIX, "/tmp/PopupUI" };
struct sockaddr_un aodvSock = {PF_UNIX, "" };

void SetUI()
{
	sUILen  = 2 + strlen(sUISock.sun_path);
	sAODVLen  = 2 + strlen(aodvSock.sun_path);
	unlink ( aodvSock.sun_path );
	sockd = socket ( PF_UNIX, SOCK_DGRAM, 0 );

	bind ( sockd, (struct sockaddr*)&aodvSock, sAODVLen);
  
	return;
}

void ResetUI()
{
	close(sockd); 
	unlink(aodvSock.sun_path); 
	return;
}

void TellUI ( int Sock, char * Msg )
{
	fprintf(stdout,"\n+++ UI POPUP MESSAGE: %s\n", Msg);
	//printf("\n---\nSock=%d sUILen=%d\n---\n",Sock,sUILen);

	if(strncmp(Msg, "MSG:",4) == 0) 
		sendto (Sock, Msg, strlen(Msg)+1, 0, 
	 			(struct sockaddr*)&sUISock, sUILen);
	else
	{
		char msg[128];
		memset(msg,0,128);
		memcpy(msg,"MSG:",4);
		memcpy(&msg[4],Msg,strlen(Msg)+1);
		//printf("New msg : %s\n",msg);
		sendto (Sock, msg , strlen(Msg)+5, 0, 
	 			(struct sockaddr*)&sUISock, sUILen);
	}
}

