/*
 *	HUT AODV for IPv6
 *	Timer queue
 *
 *	Author: Antti Tuominen <ajtuomin@tml.hut.fi>
 *
 *	$Id: tqueue.h,v 1.1 2004/02/11 20:43:26 michaela Exp $
 *
 *	Copyright (c) Antti J. Tuominen and Helsinki University of
 *	Technology.  See COPYING for license information.
 */

#ifndef __TIMER_H__
#define __TIMER_H__ 1

#include <netinet/in.h>

/*
 * Task types
 */
#define HELLO_SEND	1
#define HELLO_MISS	2
#define ROUTE_DISC	3
#define ROUTE_EXPIRE	4
#define RREQ_DUPE	5

/*
 * Initialize task queue.  Must be done befor using anything else.
 */
int taskqueue_init(void);

/* 
 * Clear alarm indentified by key.
 */
int clr_alarm(unsigned long key, unsigned char type);

/* 
 * Add task task(data) to be triggered in ms milliseconds.  Key must
 * be IPv6 address. 
 */
int add_alarm(unsigned long ms, unsigned long key, unsigned char type, 
	      void (*task)(void *args), void *data);

#endif /* __TIMER_H__ */
